DECLARE SUB xscreen (mode%)
DECLARE SUB xmouse (opt$, xmt%, xmx%, xmy%)
DECLARE SUB xpset (x%, y%, f%)
DECLARE SUB xline (x1%, y1%, x2%, y2%, f%, xlo$)
DECLARE SUB xprint (xpx%, xpy%, xptext$)
DECLARE SUB set.picture (picx%, picy%, picfile$)
DECLARE SUB load.pal (palfile$)

DECLARE SUB centerprint (x1%, y1%, text$, colo%, styl%)
DECLARE SUB s.drawdesktop (elements%)
DECLARE SUB s.init ()
DECLARE SUB waits (time%)
DECLARE SUB Windower ()
DECLARE SUB putwin (x1%, y1%, x2%, y2%, title$, bar%)
DECLARE SUB putline (ddo%)
DECLARE SUB CharPrint (PosX%, PosY%, Char%, Clr%, Style%)
DECLARE SUB textprint (PosX%, PosY%, text$, Clr%, Style%)
DECLARE SUB InitPaletteData (FileName$)
DECLARE SUB ChangePalette ()
DECLARE SUB appwin ()
DECLARE FUNCTION textlen% (text$, Style%)
DECLARE FUNCTION s.testinet% ()

DEFINT A-Z: DEF SEG = &HA000:
DIM SHARED mouse$: mouse$ = SPACE$(57)
DIM SHARED winx1, winy1, winx2, winy2, wininf$(10)
DIM SHARED mx, my, mb, grab, ox, oy
DIM SHARED distx, disty, distx2, disty2
DIM SHARED sys(50), sys$(50)
DIM SHARED FontData%(223, 16)
DIM SHARED spalette&(0 TO 255)

CONST True = -1
CONST False = 0
CONST Normal = 0
CONST Italics = 1
CONST Bold = 2

s.init
winx1 = 50: winy1 = 50: winx2 = 400: winy2 = 200
wininf$(2) = "Welcome to Edge 2.0!"

appwin


DO
xmouse "CTRL", mb, mx, my
k$ = INKEY$
IF k$ = CHR$(27) THEN END
IF k$ = CHR$(0) + "?" THEN sys$(1) = "macos": appwin
IF k$ = CHR$(0) + "@" THEN sys$(1) = "beos": appwin
IF k$ = CHR$(0) + "A" THEN sys$(1) = "redmond": appwin

Windower


LOOP

SUB appwin

putwin winx1, winy1, winx2, winy2, wininf$(2), 1

END SUB

SUB centerprint (x1, y1, text$, colo, styl)

x1 = x1 - (textlen(text$, styl) / 2)
textprint x1, y1, text$, colo, styl


END SUB

SUB ChangePalette

    DIM RGBval(0 TO 255, 0 TO 2)
    FOR n = 0 TO 255
        c& = spalette&(n)
        b = c& \ 65536: c& = c& - b * 65536
        g = c& \ 256: c& = c& - g * 256
        r = c&
        RGBval(n, 0) = r
        RGBval(n, 1) = g
        RGBval(n, 2) = b
    NEXT n

    
    WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
    FOR n = 0 TO 255
        OUT &H3C8, n            'Select attribute.
        OUT &H3C9, RGBval(n, 0) 'Write red.
        OUT &H3C9, RGBval(n, 1) 'Write green.
        OUT &H3C9, RGBval(n, 2) 'Write blue.
    NEXT n

END SUB

SUB CharPrint (PosX%, PosY%, Char%, Clr%, Style%)

Letter% = Char% - 32
IF Letter% < 0 THEN Letter% = 0

FOR Show% = 1 TO FontData%(Letter%, 0)
 
   IF (Style% AND 1) = 0 THEN
      IF (FontData%(Letter%, Show%) AND 4096) THEN xpset PosX% + Show%, PosY%, Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN xpset PosX% + Show%, PosY% + 1, Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN xpset PosX% + Show%, PosY% + 2, Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN xpset PosX% + Show%, PosY% + 3, Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN xpset PosX% + Show%, PosY% + 4, Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN xpset PosX% + Show%, PosY% + 5, Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN xpset PosX% + Show%, PosY% + 6, Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN xpset PosX% + Show%, PosY% + 7, Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN xpset PosX% + Show%, PosY% + 8, Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN xpset PosX% + Show%, PosY% + 9, Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN xpset PosX% + Show%, PosY% + 10, Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN xpset PosX% + Show%, PosY% + 11, Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN xpset PosX% + Show%, PosY% + 12, Clr%
   ELSE
      IF (FontData%(Letter%, Show%) AND 4096) THEN xpset PosX% + Show% + 3, PosY%, Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN xpset PosX% + Show% + 3, PosY% + 1, Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN xpset PosX% + Show% + 3, PosY% + 2, Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN xpset PosX% + Show% + 2, PosY% + 3, Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN xpset PosX% + Show% + 2, PosY% + 4, Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN xpset PosX% + Show% + 2, PosY% + 5, Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN xpset PosX% + Show% + 1, PosY% + 6, Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN xpset PosX% + Show% + 1, PosY% + 7, Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN xpset PosX% + Show% + 1, PosY% + 8, Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN xpset PosX% + Show%, PosY% + 9, Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN xpset PosX% + Show%, PosY% + 10, Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN xpset PosX% + Show%, PosY% + 11, Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN xpset PosX% + Show%, PosY% + 12, Clr%
   END IF
  
   IF (Style% AND 2) THEN
      CharPrint PosX% + 1, PosY%, Char%, Clr%, (Style% AND 1)
   END IF

NEXT Show%
     
PosX% = PosX% + FontData%(Letter%, 0) + 1
IF (Style% AND 2) THEN PosX% = PosX% + 1

END SUB

SUB InitPaletteData (FileName$)
   
    IF FileName$ <> "" THEN
        '*** Read palette data from file ***
        FileNo = FREEFILE
        OPEN FileName$ FOR BINARY AS #FileNo
        FOR n = 0 TO 255
            GET #FileNo, , colour&
            spalette&(n) = colour&
        NEXT n
        CLOSE #FileNo
    END IF

END SUB

SUB putline (ddo)

IF ddo = 1 THEN
xline winx1, winy1, winx2 + 1, winy2 + 1, sys(1), "BF"
xline winx1, winy1, winx2, winy2, 15, "B"
END IF

IF ddo = 0 THEN
xline winx1, winy1, winx2, winy2, sys(1), "B"
END IF
END SUB

SUB putwin (x1, y1, x2, y2, title$, bar)

SELECT CASE sys$(1)

CASE "beos"
xline x1, y1, x2 + 1, y2 + 1, sys(1), "BF"
xline x1, y1 + 18, x2, y2, 20, "B"
xline x1 + 2, y1 + 20, x2 - 2, y2 - 2, 29, "B"
xline x1 + 1, y1 + 19, x2 - 2, y1 + 19, 15, ""
xline x1 + 1, y1 + 20, x1 + 1, y2 - 2, 15, ""
xline x1 + 1, y2 - 1, x2 - 1, y2 - 1, 8, ""
xline x2 - 1, y1 + 19, x2 - 1, y2 - 2, 8, ""
xline x1 + 4, y2 - 3, x2 - 4, y2 - 3, 15, ""
xline x2 - 3, y2 - 3, x2 - 3, y1 + 21, 15, ""
xline x1 + 3, y1 + 21, x1 + 3, y2 - 4, 8, ""
xline x1 + 4, y1 + 21, x2 - 10, y1 + 21, 8, ""
xline x1 + 4, y1 + 22, x2 - 4, y2 - 4, 29, "BF"
IF bar = 1 THEN
textln = textlen(title$, Normal)
xline x1, y1, x2, y1 + 17, sys(1), "BF"
xline x1, y1, x1, y1 + 17, 20, ""
xline x1 + 1, y1, x1 + textln + 20, y1, 20, ""
xline x1 + textln + 20, y1 + 1, x1 + textln + 20, y1 + 17, 20, ""
xline x1 + 1, y1 + 1, x1 + 1, y1 + 18, 88, ""
xline x1 + 2, y1 + 1, x1 + textln + 19, y1 + 1, 88, ""
xline x1 + textln + 19, y1 + 2, x1 + textln + 19, y1 + 18, 84, ""
xline x1 + 2, y1 + 2, x1 + textln + 18, y1 + 18, 87, "BF"
textprint x1 + 10, y1 + 4, title$, 0, Normal
END IF

CASE "macos"
xline x1, y1, x2, y2, 0, "B"
xline x1 + 1, y1 + 1, x2 - 1, y2 - 1, 29, "BF"
xline x2 + 1, y1 + 1, x2 + 1, y2 + 1, 0, ""
xline x1 + 1, y2 + 1, x2, y2 + 1, 0, ""
IF bar = 1 THEN
xline x1 + 1, y1 + 18, x2 - 1, y1 + 18, 0, ""
xline x1 + 1, y1 + 1, x1 + 1, y1 + 16, 15, ""
xline x1 + 2, y1 + 1, x2 - 2, y1 + 1, 15, ""
xline x1 + 1, y1 + 17, x2 - 1, y1 + 17, 8, ""
xline x2 - 1, y1 + 1, x2 - 1, y1 + 16, 8, ""
xline x1 + 3, y1 + 3, x1 + 13, y1 + 13, 8, "B"
xline x1 + 5, y1 + 5, x1 + 15, y1 + 15, 15, "B"
xline x1 + 4, y1 + 4, x1 + 14, y1 + 14, 0, "B"
xpset x1 + 14, y1 + 3, 8: xpset x1 + 3, y1 + 14, 8
xpset x1 + 15, y1 + 4, 15: xpset x1 + 4, y1 + 15, 15
midp = x1 + ((x2 - x1) / 2)
textln = (textlen(title$, Normal) / 2)
textprint midp - textln, y1 + 3, title$, 0, Normal
FOR n = 1 TO 6
xline midp + textln + 4, y1 + (n * 2) + 2, x2 - 4, y1 + (n * 2) + 2, 8, ""
xline x1 + 18, y1 + (n * 2) + 2, midp - textln - 5, y1 + (n * 2) + 2, 8, ""
NEXT n
END IF

CASE "redmond"
xline x1, y1, x2 + 1, y2 + 1, sys(1), "BF"
xline x1, y2, x2, y2, 0, ""
xline x2, y2 - 1, x2, y1, 0, ""
xline x1, y1, x2 - 1, y1, 29, ""
xline x1, y1 + 1, x1, y2 - 1, 29, ""
xline x1 + 1, y1 + 1, x2 - 2, y1 + 1, 15, ""
xline x1 + 1, y1 + 2, x1 + 1, y2 - 2, 15, ""
xline x1 + 1, y2 - 1, x2 - 2, y2 - 1, 8, ""
xline x2 - 1, y1 + 1, x2 - 1, y2 - 1, 8, ""
xline x1 + 2, y1 + 2, x2 - 2, y2 - 2, 29, "BF"
IF bar = 1 THEN
xline x1 + 3, y1 + 3, x2 - 3, y1 + 20, 68, "BF"
textprint x1 + 5, y1 + 5, title$, 15, Bold
END IF

END SELECT

END SUB

SUB s.drawdesktop (elements)

xline 0, 0, sys(4), 16, sys(2), "BF"
xline 0, 18, sys(4), 18, 0, ""
xline 0, 0, sys(4), 0, 15, ""
xline 0, 1, 0, 17, 15, ""
xline 0, 17, sys(4), 17, 8, ""
xline sys(4) - 1, 0, sys(4) - 1, 16, 8, ""
textprint 3, 2, "Files", 0, Bold
textprint 35, 2, "System", 0, Bold
centerprint sys(4) / 2, 2, "Edge 0.04 - 26/08/05", 4, Normal

xline 0, 19, sys(4), sys(5), sys(1), "BF"

END SUB

SUB s.init
sys(7) = 3

CLS
PRINT "Welcome to Edge 2.0 "; sys(7)
waits 38

COLOR 15
PRINT
PRINT "Text boot sequence started at " + TIME$
IF COMMAND$ = "-DOS" THEN sys(3) = 1
PRINT
PRINT "Reading gfx.ini"
OPEN "system\ini\gfx.ini" FOR INPUT AS #1
Config:
proppass = 0
INPUT #1, property$
SELECT CASE property$
 CASE "bgcolour"
  INPUT #1, sys(1)
 CASE "menucolour"
  INPUT #1, sys(2)
 CASE "screenresx"
  INPUT #1, sys(4)
 CASE "screenresy"
  INPUT #1, sys(5)
 CASE "theme"
  INPUT #1, sys$(1)
 CASE ELSE
  INPUT #1, dummy
  proppass = 1
END SELECT
IF proppass = 1 THEN
 COLOR 4: PRINT "  " + property$ + " error"
ELSE
 COLOR 2: PRINT "  " + property$ + " ok"
END IF
IF EOF(1) THEN CLOSE #1 ELSE GOTO Config:

COLOR 15
PRINT
PRINT "System Font"
OPEN "system/sserif.fon" FOR BINARY ACCESS READ AS #1
   IF LOF(1) > 0 THEN
      FOR FontRead% = 0 TO 223
         GET #1, , FontData%(FontRead%, 0)
         FOR FontLine% = 1 TO FontData%(FontRead%, 0)
            GET #1, , FontData%(FontRead%, FontLine%)
         NEXT FontLine%
      NEXT FontRead%
      COLOR 2: PRINT "  ok"
   ELSE
      COLOR 4: PRINT "  error"
      COLOR 7: PRINT "   the font file specified in system.ini cannot be found."
      PRINT "   check to see if the file exists before downloading a new file."
      SYSTEM
   END IF
CLOSE #1

COLOR 15
PRINT
PRINT "Scanning for hardware changes"
COLOR 2: PRINT "  ok"

COLOR 15
PRINT
PRINT "Building file index"
SHELL "cd system"
IF sys(3) = 1 THEN
 SHELL "SEARCH.BAT EXE"
ELSE
 SHELL "start /MIN /WAIT search.bat exe"
END IF
OPEN "index.dat" FOR INPUT AS #1
DO WHILE NOT EOF(1): INPUT #1, dummy$: c = c + 1: LOOP
COLOR 2: PRINT " " + STR$(c) + " EXEs indexed"
CLOSE #1
SHELL "if exist idexe.dat del idexe.dat"
SHELL "ren index.dat idexe.dat"
c = 0
IF sys(3) = 1 THEN
 SHELL "SEARCH.BAT APP"
ELSE
 SHELL "start /MIN /WAIT search.bat app"
END IF
OPEN "index.dat" FOR INPUT AS #1
DO WHILE NOT EOF(1): INPUT #1, dummy$: c = c + 1: LOOP
COLOR 2: PRINT " " + STR$(c) + " APPs indexed"
SHELL "if exist idapp.dat del idapp.dat"
SHELL "ren index.dat idapp.dat"
SHELL "cd .."

COLOR 15
PRINT
PRINT "Testing internet configuration"
IF sys(3) = 0 THEN dummy2 = s.testinet ELSE dummy2 = 2
IF dummy2 = 1 THEN COLOR 2: PRINT "  ok"
IF dummy2 = 0 THEN COLOR 4: PRINT "  error"
IF dummy2 = 2 THEN COLOR 4: PRINT " disabled in DOS mode"





COLOR 15
PRINT
PRINT "Switching screen mode to" + STR$(sys(4)) + " x" + STR$(sys(5))
PRINT "Loading palette"
PRINT
PRINT "Text boot sequence finished"
waits 19

SELECT CASE sys(5)
 CASE 400
  xscreen &H100
 CASE 480
  xscreen &H101
 CASE 600
  xscreen &H103
 CASE 768
  xscreen &H105
END SELECT

REDIM StandardPal&(1 TO 1)
InitPaletteData Path$ + "system/palette.pal"
ChangePalette

xline 0, 0, sys(4), sys(5), sys(1), "BF"
srt = (sys(4) / 2) - 250
IF sys$(1) = "beos" THEN sys$(1) = "macos": sysdum = 1
putwin srt - 3, (sys(5) / 2) - 153, (sys(4) / 2) + 252, (sys(5) / 2) + 152, "", 0
IF sysdum = 1 THEN sys$(1) = "macos"
set.picture srt, (sys(5) / 2) - 150, "system/gfx/boot.gif"


set.picture srt + 120, (sys(5) / 2), "system/gfx/config.gif"

set.picture srt + 156, (sys(5) / 2), "system/gfx/display.gif"
textln = (textlen("Loading display settings", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading display settings", 0, Normal
waits 19
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading display settings", 29, Normal

'set.picture srt + 192, (sys(5) / 2), "system/gfx/search.gif"

set.picture srt + 192, (sys(5) / 2), "system/gfx/mouse.gif"
textln = (textlen("Initialising input", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Initialising input", 0, Normal
xmouse "ON", 0, 0, 0
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Initialising input", 29, Normal

set.picture srt + 228, (sys(5) / 2), "system/gfx/access.gif"
textln = (textlen("Loading accessibility tools", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading accessibility tools", 0, Normal
waits 19
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading accessibility tools", 29, Normal


set.picture srt + 264, (sys(5) / 2), "system/gfx/apps.gif"
textln = (textlen("Loading startup applications", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading startup applications", 0, Normal
waits 19
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Loading startup applications", 29, Normal

set.picture srt + 300, (sys(5) / 2), "system/gfx/desktop.gif"
textln = (textlen("Restoring session", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Restoring session", 0, Normal
waits 19
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Restoring session", 29, Normal

set.picture srt + 336, (sys(5) / 2), "system/gfx/desktop.gif"
textln = (textlen("Welcome to Edge 2.01", Normal) / 2)
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Welcome to Edge 2.0", 0, Normal
waits 19
textprint sys(4) / 2 - textln, (sys(5) / 2) + 70, "Welcome to Edge 2.0", 29, Normal
waits 19

s.drawdesktop 2

END SUB

FUNCTION s.testinet



SHELL "cd system"
SHELL "cd internet"

SHELL "getnet.exe http://www.mcinnes.uk.net/kyle/inet.txt"

OPEN "out.dat" FOR INPUT AS #10
IF NOT LOF(10) = 0 THEN INPUT #10, outstring$
CLOSE #10
SHELL "cd .."
SHELL "cd .."
IF outstring$ = "/kyle/inet.txt" THEN s.testinet = 1 ELSE s.testinet = 0



END FUNCTION

'=========================================<lpardini@cefex.com>=
'Returns the pixel lenght of a string with my multispaced font.
'Text$  iso-8859-1 string
'Style% Normal, Bold, Italic, or Bold+Italic
'==============================================================
FUNCTION textlen% (text$, Style%)
  
   FOR Proc% = 1 TO LEN(text$)
      Letter% = ASC(MID$(text$, Proc%, 1))
      Lenght% = Lenght% + FontData%(Letter% - 32, 0)
      IF (Style% AND 2) THEN Lenght% = Lenght% + 1
      Lenght% = Lenght% + 1
   NEXT Proc%
   IF (Style% AND 1) THEN Lenght% = Lenght% + 3
   textlen% = Lenght%

END FUNCTION

'====================<lpardini@cefex.com>=
'Shows a string using my multispaced font.
'PosX%  Pixel X position
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'=========================================
SUB textprint (PosX%, PosY%, text$, Clr%, Style%)
   FOR Proc% = 1 TO LEN(text$)
      Letter% = ASC(MID$(text$, Proc%, 1))
      CharPrint PosX%, PosY%, Letter%, Clr%, Style%
   NEXT Proc%
END SUB

SUB waits (time)

DEF SEG = 0
POKE (1132), 0
Count:
IF PEEK(1132) < time THEN GOTO Count:
DEF SEG

END SUB

SUB Windower

IF mb = 1 THEN
  IF grab = 0 AND mx > winx1 AND mx < winx2 AND my > winy1 AND my < winy1 + 18 THEN
  grab = 1
  distx = mx - winx1
  disty = my - winy1
  distx2 = winx2 - mx
  disty2 = winy2 - my
  putline 1
  END IF
END IF

IF grab = 1 THEN
IF ox <> mx OR oy <> my THEN
 putline 0
 winx1 = mx - distx
 winy1 = my - disty
 winx2 = mx + distx2
 winy2 = my + disty2
 putline 1
END IF
ox = mx
oy = my

END IF


IF mb = 0 AND grab = 1 THEN
grab = 0
xmouse "OFF", 0, 0, 0
appwin
xmouse "ON", 0, 0, 0
END IF


END SUB

